#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"






#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Gold








extern string note_TimeFrames  = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string TimeFrame        = "Current time frame";
extern bool   Interpolate      = true;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;






double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double trend[];


string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;




int init()
  {
   IndicatorBuffers(4);   
   SetIndexBuffer(0,ExtBuffer1);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,trend);
   
   
   
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   
   
   IndicatorShortName(timeFrameToString(timeFrame)+" AO ");
   

   return(0);
  }
   
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }
   
   if (calculateValue || timeFrame == Period())
   {
         
         
   for(i=limit; i>=0; i--)
   {
   ExtBuffer3[i] = iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,i);
   ExtBuffer1[i] = 0;
   ExtBuffer2[i] = 0;
   
   
  if (ExtBuffer3[i] > ExtBuffer3[i+1]) 
      ExtBuffer1[i] = ExtBuffer3[i]; 
      else
      ExtBuffer2[i] = ExtBuffer3[i]; 
     
      trend[i] = trend[i+1];
  if (ExtBuffer3[i] > 0 && ExtBuffer3[i+1] <= 0) trend[i] =  1; 
  if (ExtBuffer3[i] < 0 && ExtBuffer3[i+1] >= 0) trend[i] = -1; 
  
  }
  manageAlerts();
  return(0);
}

   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
   int y         = iBarShift(NULL,timeFrame,Time[i]);
   ExtBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",0,y);
   ExtBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",1,y);
   ExtBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",2,y);
   trend[i]      = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",3,y);
   
   
   if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
            ExtBuffer3[i+k] = ExtBuffer3[i] + (ExtBuffer3[i+n] - ExtBuffer3[i])*k/n;
            if (ExtBuffer1[i]!=0) ExtBuffer1[i+k] = ExtBuffer3[i+k];
            if (ExtBuffer2[i]!=0) ExtBuffer2[i+k] = ExtBuffer3[i+k];
          }
   }
   manageAlerts();
   return(0);         
}


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," AO changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," AO "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
   